|  | Home · All Classes · Main Classes · Grouped Classes · Modules · Functions |

# glwidget.h Example File
opengl/grabber/glwidget.h

     /****************************************************************************
     **
     ** Copyright (C) 2005-2006 Trolltech ASA. All rights reserved.
     **
     ** This file is part of the example classes of the Qt Toolkit.
     **
     ** This file may be used under the terms of the GNU General Public
     ** License version 2.0 as published by the Free Software Foundation
     ** and appearing in the file LICENSE.GPL included in the packaging of
     ** this file.  Please review the following information to ensure GNU
     ** General Public Licensing requirements will be met:
     ** http://www.trolltech.com/products/qt/opensource.html
     **
     ** If you are unsure which license is appropriate for your use, please
     ** review the following information:
     ** http://www.trolltech.com/products/qt/licensing.html or contact the
     ** sales department at sales@trolltech.com.
     **
     ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
     ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
     **
     ****************************************************************************/

     #ifndef GLWIDGET_H
     #define GLWIDGET_H

     #include <QGLWidget>

     class GLWidget : public QGLWidget
     {
         Q_OBJECT

     public:
         GLWidget(QWidget *parent = 0);
         ~GLWidget();

         int xRotation() const { return xRot; }
         int yRotation() const { return yRot; }
         int zRotation() const { return zRot; }

     public slots:
         void setXRotation(int angle);
         void setYRotation(int angle);
         void setZRotation(int angle);

     signals:
         void xRotationChanged(int angle);
         void yRotationChanged(int angle);
         void zRotationChanged(int angle);

     protected:
         void initializeGL();
         void paintGL();
         void resizeGL(int width, int height);
         void mousePressEvent(QMouseEvent *event);
         void mouseMoveEvent(QMouseEvent *event);

     private slots:
         void advanceGears();

     private:
         GLuint makeGear(const GLfloat *reflectance, GLdouble innerRadius,
                         GLdouble outerRadius, GLdouble thickness,
                         GLdouble toothSize, GLint toothCount);
         void drawGear(GLuint gear, GLdouble dx, GLdouble dy, GLdouble dz,
                       GLdouble angle);
         void normalizeAngle(int *angle);

         GLuint gear1;
         GLuint gear2;
         GLuint gear3;
         int xRot;
         int yRot;
         int zRot;
         int gear1Rot;

         QPoint lastPos;
     };

     #endif